/*
 * Copyright 2007 Phidgets Inc.  All rights reserved.
 */

import com.phidgets.*;
import com.phidgets.event.*;
import java.util.*;
import java.io.*;

		
public class keypadUnlocker
{
	InterfaceKitPhidget ik;
	String keyCode = "";
	int index;
	boolean[] flags = {false, false, false, false};
	String UNLOCK = "0123";
	
	public void runFirst() throws Exception{
		
		index = 0;
		
		ik = new InterfaceKitPhidget();
		
////////////////////////////////////////////////////////////////////////////////////////////////
		//Attach, dettach and error handlers
		ik.addAttachListener(new AttachListener() {
			public void attached(AttachEvent ae) {

			}
		});
		ik.addDetachListener(new DetachListener() {
			public void detached(DetachEvent ae) {
				System.out.println("detachment of " + ae);
			}
		});
		ik.addErrorListener(new ErrorListener() {
			public void error(ErrorEvent ee) {
				System.out.println(ee);
			}
		});		
////////////////////////////////////////////////////////////////////////////////////////////////		
		//important handlers
		//interface kit
		ik.addSensorChangeListener(new SensorChangeListener() {
			public void sensorChanged(SensorChangeEvent se) {
				return;
			}
		});
		
		ik.addInputChangeListener(new InputChangeListener() {
			public void inputChanged(InputChangeEvent oe) {
				if(oe.getState() == false) //we want to ignore the changes that occur from depressing a button
					return;
				
				keyCode = keyCode + oe.getIndex(); //append new entry to current attempt
				index++; //increment place marker

				if(keyCode.equals(UNLOCK)){ //if the attempt = the accepted answer
					try{
						ik.setOutputState(0,true); //unlock
						Thread.sleep(2000); //pause for opening
						ik.setOutputState(0,false); //relock
						keyCode = ""; //reset the current attempt to blank
					}
					catch(Exception e){}
				}
				if(index ==4){ //if the current attempt has reached the 4 digit limit, reset.
					index = 0;
					keyCode = "";
				}
			}
		});
///////////////////////////////////////////////////////////////////////////////////////////////
		//open devices
		ik.openAny();
		System.out.println("waiting for InterfaceKit attachment...");
		ik.waitForAttachment(1000);
	
///////////////////////////////////////////////////////////////////////////////////////////////
		//close on input from user
		System.out.println("Outputting events.  Input to stop.\n");

		System.in.read();
		System.out.print("closing...");
		ik.close();
		System.out.println(" ok");
	}

	public static final void main(String args[]) throws Exception {
		keypadUnlocker test = new keypadUnlocker();
		test.runFirst();
	}
}
